package com.liang.service.impl;

import com.liang.entity.BaseArea;
import com.liang.dao.BaseAreaDao;
import com.liang.service.BaseAreaService;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * (BaseArea)表服务实现类
 *
 * @author makejava
 * @since 2023-02-15 23:13:13
 */
@Service("baseAreaService")
public class BaseAreaServiceImpl implements BaseAreaService {
    @Resource
    private BaseAreaDao baseAreaDao;

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public BaseArea queryById(Integer id) {
        return this.baseAreaDao.queryById(id);
    }

    /**
     * 分页查询
     *
     * @param baseArea    筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    @Override
    public Page<BaseArea> queryByPage(BaseArea baseArea, PageRequest pageRequest) {
        long total = this.baseAreaDao.count(baseArea);
        return new PageImpl<>(this.baseAreaDao.queryAllByLimit(baseArea, pageRequest), pageRequest, total);
    }

    /**
     * 新增数据
     *
     * @param baseArea 实例对象
     * @return 实例对象
     */
    @Override
    public BaseArea insert(BaseArea baseArea) {
        this.baseAreaDao.insert(baseArea);
        return baseArea;
    }

    /**
     * 修改数据
     *
     * @param baseArea 实例对象
     * @return 实例对象
     */
    @Override
    public BaseArea update(BaseArea baseArea) {
        this.baseAreaDao.update(baseArea);
        return this.queryById(baseArea.getId());
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Integer id) {
        return this.baseAreaDao.deleteById(id) > 0;
    }

    @Override
    public List<BaseArea> queryAll() {
        return this.baseAreaDao.queryAll();
    }

    @Override
    public List<BaseArea> getCountryList(Map map) {
        return this.baseAreaDao.getCountryList(map);
    }

    @Override
    public List<Map<String, String>> getCountry() {
        return this.baseAreaDao.getCountry();
    }
}
